#include "stdafx.h"
#include "connection.h"

#include "data.h"

C3DCursor cursor;


char  g_strBaseFileName[MAX_STRING]="-",
	g_strOutputFileName[MAX_STRING]="temp";


CGL * gl=NULL;

GLfloat alpha=0.0,beta=0.0;
void OnRender(void);
void OnTimer(GLint value);
void OnSpecialKey(GLint,GLint,GLint);
void OnKeyboard(char p_cKey,GLint p_nx, GLint p_ny);
void WriteOk(void);
void OnWire(void);
void OnConstructPaint(void);
void OnRed(GLfloat);
void OnGreen(GLfloat);
void OnBlue(GLfloat);
void ScanArguments(int, char *[]);

void InitializeUserInterface(void);


int main(int argc, char * argv[])
{
	
	try{
	//ScanArguments(argc,argv);
	setvbuf( stdout, NULL, _IONBF, 0 );
	printf("%s %s.\n","3D_Frame_Editor",__DATE__);


	printf("Input base file (or type \"-\" if not): ");
	gets(g_strBaseFileName);
	if ((g_strBaseFileName[0]=='-')&&(g_strBaseFileName[1]==0)) g_strBaseFileName[0]=0;
	printf("Input  output file name (\"-\" - no out):");
	gets(g_strOutputFileName);
	//printf("Input shininess:");
	//float fShininess;
	//scanf("%f",&fShininess);
	printf("Initializing OpenGL");
	glutInit(&argc,argv);
	gl=new CGL("3D_Frame_Editor");
	gl->SetRenderProc(OnRender);
	gl->SetTimerProc(OnTimer);
	WriteOk();
	InitializeUserInterface();
	printf("Initializing Zero Frame");
	pFrame=new CGLFrame(200);
	WriteOk();
	printf("Initializing 3DCursor...");
	cursor.SetFrame(pFrame);
	//cursor.SetShininess(fShininess);
	printf("Loading \"%s\"...",g_strBaseFileName);
	cursor.SetOutputFileName(g_strBaseFileName,g_strOutputFileName);
	WriteOk();
	gl->SetSpecialKeyProc(OnSpecialKey);
	gl->SetKeyboardProc(OnKeyboard);

	

	 glutMainLoop();
		puts("end main loop");
	}
	catch(...)
	{
		puts("A error detected");
		return 1;
	}

	return 0;
}


void WriteOk(void)
{
	printf("%s%s",strOK,cpputils::GetTimeString());
}
void OnRender(void)
{
	gl->SetPointLight(GL_LIGHT0,CGLVector3(0.0f,100.0f,100.0f),CGLColor(1.0f,1.0f,1.0f));
	glColor4f(1.0,1.0,1.0,1.0);
	glTranslatef(0.0,0.0,g_fz);
	glRotatef(alpha,0.0,1.0,0.0);
	glRotatef(beta,1.0,0.0,0.0);
	pFrame->Draw();
	cursor.Draw();
}


void OnTimer(GLint value)
{
	alpha+=0.0f;
	if (alpha>=360) alpha=0.0f;
}

void OnSpecialKey(GLint p_nKey, GLint p_nx, GLint p_ny)
{
	const GLfloat fStep=0.1;
	switch (p_nKey)
	{
	case GLUT_KEY_LEFT:
		cursor.m_fx-=cursor.m_fStep;
		break;
	case GLUT_KEY_RIGHT:
		cursor.m_fx+=cursor.m_fStep;
		break;
	case GLUT_KEY_UP:
		cursor.m_fy+=cursor.m_fStep;
		break;
	case GLUT_KEY_DOWN:
		cursor.m_fy-=cursor.m_fStep;
		break;
	
	}
}

void OnKeyboard(char p_cKey, GLint p_nx, GLint p_ny)
{
	switch (p_cKey)
	{
	case 27:
		cursor.~C3DCursor();
		exit(1);
		break;
	case ' ':
		cursor.SetSphereChange();
		break;
	case 'S':
	case 's':
	case '':
	case '':
		alpha-=1.0;
		break;
	case 'F':
	case 'f':
	case '':
	case '':
		alpha+=1.0;
		break;
	case 'E':
	case 'e':
	case '':
	case '':
		beta+=1.0;
		break;
	case 'D':
	case 'd':
	case '':
	case '':
		beta-=1.0;
		break;
	case 'r':
	case 'R':
	case '':
	case '':
		g_fz-=1.0;
		break;
	case 'T':
	case 't':
	case '':
	case '':
		g_fz+=1.0;
		break;
	case '1':
		cursor.SetStartPoint();
		break;
	case '2':
		cursor.SetEndPoint();
		break;
	case '0':
		cursor.LoadCommandsFromFile("INPUT");
		break;
	case 'A':
	case 'a':
	case '':
	case '':
		cursor.m_fz-=cursor.m_fStep;
		break;
	case 'Z':
	case 'z':
	case '':
	case '':
		cursor.m_fz+=cursor.m_fStep;
		break;
	case '+':
	case '=':
		cursor.m_fRadius+=0.1;
		break;
	case '-':
		cursor.m_fRadius-=0.1;
		break;
		
	}
}

void OnWire(void)
{
	static n=1;
	n=(n+1)%3;
	switch (n)
	{
	case 0:
	glPolygonMode(GL_FRONT,GL_LINE);
	break;
	case 1:
		glPolygonMode(GL_FRONT,GL_FILL);
		break;
	case 2:
		glPolygonMode(GL_FRONT,GL_POINT);
		break;
	}
}

void OnConstructPaint(void)
{
	cursor.m_nMode=(cursor.m_nMode+1)%2;
}

void OnRed(GLfloat p_fValue)
{
	cursor.m_Color.r=p_fValue;
}

void OnGreen(GLfloat p_fValue)
{
	cursor.m_Color.g=p_fValue;
}

void OnBlue(GLfloat p_fValue)
{
	cursor.m_Color.b=p_fValue;
}

void OnShininess(GLfloat p_fValue)
{
	cursor.SetShininess(p_fValue*128.0);
}

void OnParentPoint()
{
	cursor.SetParentPoint();
}
void InitializeUserInterface(void)
{
	printf("Initializing User Interface");
	CGLControl* p;
	p=new CGLLabel(-1.0,0.9,2.0,0.1,"  ");

	g_Red=new CGLSlider(0.5,0.8,0.4,0.1,"",OnRed);

	g_Green=new CGLSlider(0.5,0.7,0.4,0.1,"",OnGreen);

	g_Blue=new CGLSlider(0.5,0.6,0.4,0.1,"",OnBlue);

	p=new CGLButton(-0.9,-0.9,0.5,0.1,"//",OnWire);

	g_ConstructPaint=new CGLButton(0.5,0.0,0.5,0.1,"/",OnConstructPaint);

	p=new CGLButton(0.5,-0.2,0.5,0.1,"  ",OnConnectionPoint);

	p=new CGLButton(0.5,-0.4,0.5,0.1,"  ",OnParentPoint);
	p= new CGLSlider(-0.9,0.9,0.5,0.1,"Shininess:",OnShininess);
	WriteOk();
	

}

void ScanArguments(int argc, char *argv[])
{
	for (int n=0; n<argc;n++)
	{
		if (strcmp(argv[n],"object")==0)
		{
			g_nSituation=S_CONSTRUCT_OBJECT;
			return;
		}

		

	}

}