#include "stdafx.h"
#include "files.h"
#include "m.h"
C3DObject * g_p3do=NULL;
CSimple3DObject *g_ps3do=NULL;
int g_nSelectedConnection=0;

//  
GLfloat alpha=0.0,beta=0.0;
GLfloat g_fz=-10.0;

void OnRender(void);
void InitializeUserInterface(void);
void OnKeyboard(char ch, GLint x, GLint y);
void OnSpecialKey(GLint key, GLint x, GLint y);


int main(int argc, char *argv[])
{
	string strBase;
	strBase.reserve(20);
	setvbuf(stdout, NULL, _IONBF, 0 );
	printf("%s %s.\n","3D_Object_Editor",__DATE__);
	printf("Input base file name: ");
	scanf("%20s",strBase.data());
	try{
		g_p3do=new C3DObject();
		g_p3do->SetBaseSimple3DObject(strBase.c_str(),1.0);
		g_ps3do=g_p3do->GetBaseSimple3DObject();
		if (!g_ps3do) throw 1;

		CGL::InitOpenGL("3D_Object_Editor",&argc,argv);
		
		InitializeUserInterface();
		CGL::SetRenderProc(OnRender);
		CGL::SetKeyboardProc(OnKeyboard);
		CGL::SetSpecialKeyProc(OnSpecialKey);
		CGL::MainLoop();
		puts("end main loop");
		
	}
	catch (...){
		puts("A error detected during initialization.");
		return 1;
	}
	return 0;
}



void InitializeUserInterface(void)
{
	CGLControl*p=new CGLButton(0.5,0.9,0.5,0.1," ",ConnectObject);
	p=new CGLButton(0.5,0.7,0.5,0.1,"  ",SaveToFile);
	if (!p) throw 1;
	p=new CGLButton(0.5,0.5,0.5,0.1,"  ",LoadFromFile);
	if (!p) throw 1;
}



void OnRender(void)
{
	CGL::SetPointLight(GL_LIGHT0,CGLVector3(0.0,100.0,-10.0),CGLColor(1.0,1.0,1.0));
	glTranslatef(0.0,0.0,g_fz);
	glRotatef(alpha,0.0,1.0,0.0);
	glRotatef(beta,1.0,0.0,0.0);

		//glTranslatef(0.0,0.0,-10.0);

	if (g_ps3do->GetConnectionsCount()>0)
	{
	const CConnectionPoint & cp=g_ps3do->GetConnectionPoint(g_nSelectedConnection);
	glColor3f(0.0,1.0,0.0);
	glBegin(GL_LINES);
		glVertex3f(cp.m_fx,1000,cp.m_fz);
		glVertex3f(cp.m_fx,-1000,cp.m_fz);
		glVertex3f(1000,cp.m_fy,cp.m_fz);
		glVertex3f(-1000,cp.m_fy,cp.m_fz);
		glVertex3f(cp.m_fx,cp.m_fy,1000);
		glVertex3f(cp.m_fx,cp.m_fy,-1000);
	glEnd();
	}
	g_p3do->Draw();
}

void OnKeyboard(char ch, GLint x, GLint y)
{
	switch (ch)
	{
	case 'S':
	case 's':
	case '':
	case '':
		alpha-=1.0;
		break;
	case 'F':
	case 'f':
	case '':
	case '':
		alpha+=1.0;
		break;
	case 'E':
	case 'e':
	case '':
	case '':
		beta+=1.0;
		break;
	case 'D':
	case 'd':
	case '':
	case '':
		beta-=1.0;
		break;
	case 'r':
	case 'R':
	case '':
	case '':
			g_fz-=1.0;
		break;
	case 'T':
	case 't':
	case '':
	case '':
		g_fz+=1.0;
		break;
	}

}

void OnSpecialKey(GLint key, GLint x, GLint y)
{
	switch (key)
	{
	case GLUT_KEY_F2:
		g_nSelectedConnection++;
		if (g_nSelectedConnection>=g_ps3do->GetConnectionsCount()) g_nSelectedConnection=0;
		break;
	case GLUT_KEY_F3:
		if (g_ps3do)
		{
			CSimple3DObject *p=g_ps3do->GetConnectedSimple3DObject(g_nSelectedConnection);
			if (p->GetFolder()!="") 
			{
				g_ps3do=p;
				g_nSelectedConnection=0;
			}
		}
		break;
	case GLUT_KEY_F4:
		g_ps3do=g_p3do->GetBaseSimple3DObject();
		break;
	}

}