// gleditbox.h: interface for the CGLEditBox class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_GLEDITBOX_H__6AEE17CC_ACA5_4F30_A91D_A838D9E14A0E__INCLUDED_)
#define AFX_GLEDITBOX_H__6AEE17CC_ACA5_4F30_A91D_A838D9E14A0E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "importexport.h"
#include "gllabel.h"


typedef void PFNONENDEDITPROC(const string& p_strEnterText);
class CGL_API  CGLEditBox : public CGLLabel  
{
//#ifdef CGL_EXPORTS
protected:
	GLint m_nEnterTextMaxLength;
	GLint m_nEnterTextCurrentLength;

	PFNONENDEDITPROC *m_pfnOnEndEdit;
//#endif
	char * m_strEnterText;

public:
	CGLEditBox(GLfloat p_fx,GLfloat p_fy,
		GLfloat p_fWidth,GLfloat p_fHeight,
		const string& p_strText,
		GLint p_nEnterTextMaxLength,
		PFNONENDEDITPROC * p_pfnOnEndEdit);
	char * DuplicateEnteredText(void) {return strdup(m_strEnterText);};
	char * GetPointToEnteredString(void) {return m_strEnterText;};
	virtual void Draw();
	virtual void OnKeyboard(char p_chKey,GLint p_nx,GLint p_ny);
	virtual void OnSpecialKey(GLint p_nKey,GLint p_nx,GLint p_ny);
	virtual ~CGLEditBox();

};

#endif // !defined(AFX_GLEDITBOX_H__6AEE17CC_ACA5_4F30_A91D_A838D9E14A0E__INCLUDED_)
