
#include <time.h>
#include "cpputils.h"
#include <string>
#include <assert.h>
using std::string;

int cpputils::Round(float x) 
{
	if (x>0.0f)
	{
		return (int)(x+0.5f);
	}
	else
	{
		return (int)(x-0.5f);
	}
}

char *cpputils::GetTimeString(void)
{
	time_t CurrentTime=time(NULL);
	return asctime(localtime(&CurrentTime));	
}


int cpputils::GetSign(float x)
{
	if (x>0.0)
		return 1;
	if (x<0.0) return -1;
	return 0;
}

FINDDATA* cpputils::FindFirst(const char *p_strfilespec)
{
	FINDDATA *pfd=new FINDDATA;
	if (!pfd) return 0;
	int nResult=_findfirst(p_strfilespec,&pfd->m_FileInfo);
	if (nResult==-1) return 0;
	pfd->m_strFileName=pfd->m_FileInfo.name;
	pfd->m_nHandle =nResult;
	while ((string(pfd->m_strFileName)==".")||(string(pfd->m_strFileName)==".."))
	{
		if (!FindNext(pfd))
		{
			FindClose(pfd);
			delete pfd;
			return 0;
		}
	}

	return pfd;
}

int cpputils::FindNext(FINDDATA* p_fdFileInfo)
{

	int nResult=_findnext(p_fdFileInfo->m_nHandle,&p_fdFileInfo->m_FileInfo);
	if (nResult==0) 
	{
		p_fdFileInfo->m_strFileName=p_fdFileInfo->m_FileInfo.name;
		return 1;
	}
	return 0;
}

void cpputils::FindClose(FINDDATA* p_fdFileInfo)
{
	_findclose(p_fdFileInfo->m_nHandle);
	delete p_fdFileInfo;
}