// 3dcursor.h: interface for the C3DCursor class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_3DCURSOR_H__38D486EF_5E78_4EC7_BC70_7EB5CBE7D155__INCLUDED_)
#define AFX_3DCURSOR_H__38D486EF_5E78_4EC7_BC70_7EB5CBE7D155__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include "importexport.h"
#include <stdio.h>
#include <vector>
#include "connectionpoint.h"
using std::vector;

typedef vector<CConnectionPoint> CONNECTION_POINT_VECTOR;
enum {
	MODE_CONSTRUCT,
		MODE_PAINT,
};
class C3DCursor  
{
private:

	GLfloat m_fStartx,m_fStarty,m_fStartz,m_fStartRadius;
	CGLColor m_StartColor;
	CGLFrame* m_pFrame;
	char * m_strBaseFileName;
	char * m_strOutputFileName;
	FILE* m_of,*m_ofmeta;
	CONNECTION_POINT_VECTOR m_vctConnectionPoints;
	GLfloat m_fParentx,m_fParenty,m_fParentz;
public:
	C3DCursor(GLfloat p_fx=0.0,GLfloat p_fy=0.0, GLfloat p_fz=0.0, CGLFrame* p_pFrame=NULL);
	virtual ~C3DCursor();
	GLfloat m_fx,m_fy,m_fz;
	CGLColor m_Color;
	GLfloat m_fRadius;
	GLfloat m_fStep;
	int m_nMode;
	void SetStartPoint(void);
	void SetFrame(CGLFrame * p_pFrame);
	void SetShininess(GLfloat p_fShininess);
	GLfloat GetShininess(void);
	int SetOutputFileName(char *p_strBaseFileName,char *p_strOutputFileName) ;
	int LoadCommandsFromFile(const char *p_strFileName);
	void SetEndPoint(void);
	void SetSphereChange(void);
	void SetParentPoint(void);
	void Draw(void);
	void AddConnectionPoint(int p_nNumber);
	void SetConnectionPoint(int p_nIndex,const CConnectionPoint& p_pt);
	void RemoveConnectionPoint(int p_nIndex);
	int GetConnectionPointsCount(void);
	const CConnectionPoint& GetConnectionPoint(int p_nIndex);

};

#endif // !defined(AFX_3DCURSOR_H__38D486EF_5E78_4EC7_BC70_7EB5CBE7D155__INCLUDED_)
