// 3DObject.cpp: implementation of the C3DObject class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "3dobject.h"
#include <stack>

using std::stack;
typedef stack<CSimple3DObject> S3DO_STACK;
const string g_strFilePrefix=string("C3DOBJECT");

int C3DObject::m_nGlobalGraphQuality=100;
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

C3DObject::C3DObject()
{
	m_s3doBase=NULL;
}

C3DObject::C3DObject(CSimple3DObject p_s3doBase)
{
	//m_pSimple3DObject
}


void C3DObject::SetBaseSimple3DObject(const string& p_strFolderName, float p_fGraphQuality)
{
	m_s3doBase=new CSimple3DObject(p_strFolderName,p_fGraphQuality);
}

C3DObject::C3DObject(const string& p_strFileName)
{
	FILE *inf=fopen(p_strFileName.c_str(),"r");
	if (!inf) throw 1;
	char *buf=new char[g_strFilePrefix.length()+1];
	if (1!=fread((void*)buf,g_strFilePrefix.length(),1,inf)) throw 1;
	buf[g_strFilePrefix.length()]=0;
	if (g_strFilePrefix!=string(buf)) throw 1;
	delete [] buf;
	m_s3doBase=CSimple3DObject::LoadFromFile(inf);
	fclose(inf);
}

C3DObject::~C3DObject()
{
	
}


CSimple3DObject * C3DObject::GetBaseSimple3DObject(void)
{
	return m_s3doBase;
}

void C3DObject::SetGlobalGraphQuality(int p_nGlobalGraphQuality)
{
	m_nGlobalGraphQuality=p_nGlobalGraphQuality;
}

int C3DObject::GetGlobalGraphQuality(void)
{
	return m_nGlobalGraphQuality;
}

/*
void C3DObject::RemoveConnection(int p_nIndex)
{
	
}

const CConnection& C3DObject::GetConnection(int p_nIndex)
{
	return m_vctConnections.at(p_nIndex);
	
}

void C3DObject::SetConnection(int p_nIndex, const CConnection& p_NewConnection)
{
	m_vctConnections.at(p_nIndex)=p_NewConnection;
}

int C3DObject::GetConnectionsCount(void)
{
	return m_vctConnections.size();
}
*/

void C3DObject::Draw()
{
	S3DO_STACK s3dostack;
	
	m_s3doBase->Draw();
}

void C3DObject::SaveToFile(const string& p_strFileName)
{
	FILE * of=fopen(p_strFileName.c_str(),"w");
	if (!of) throw 1;
	if (1!=fwrite((const void*)g_strFilePrefix.c_str(),g_strFilePrefix.length(),1,of)) throw 1;
	m_s3doBase->SaveToFile(of);
	fclose(of);
}

