#ifndef SIMPLE3DOBJECT_INCLUDED
#define SIMPLE3DOBJECT_INCLUDED
#include "gl.h"
#include "connectionpoint.h"
struct CSimple3DObject{
private:
	CGLFrame *m_pFrame;
	CSimple3DObject ** m_as3do;
	CConnectionPoint ** m_acp;
	int m_nConnectionsCount;
	string m_strFolder;
	CSimple3DObject * parent;
	float m_fGraphQuality;
	float m_fStructureFlexibility;
public:
	CSimple3DObject();
	CSimple3DObject(const string & p_strFolder,float p_fGraphQuality,float p_fStructureFlexibility=1.0);
	~CSimple3DObject();
	int GetConnectionsCount(void) {return m_nConnectionsCount;}
	CSimple3DObject * GetConnectedSimple3DObject(int p_nIndex) ;//{return m_as3do[p_nIndex];}
	const CConnectionPoint & GetConnectionPoint(int p_nIndex);// {return *m_acp[p_nIndex];}
	void SetConnectionToSimple3DObject(int p_nIndex, const string & p_strFolder,float p_fGraphQuality, float p_fStructureFlexibility=1.0);
	void Draw();
	void SaveToFile(FILE * p_of);
	static CSimple3DObject* LoadFromFile(FILE* p_of);
	string GetFolder(void) {return m_strFolder;}
	bool operator <(CSimple3DObject& p_s3do);
};


#endif