#include "stdafx.h"
#include "simple3dobject.h"
#include "3dcursor.h"
#include <fstream.h>
#include <time.h>
#include "3dobject.h"
#include "cpputils.h"
#include "3dwgutils.h"

CSimple3DObject::CSimple3DObject()
{
	m_pFrame=NULL;
	m_as3do=NULL;
	m_acp=NULL;
	m_nConnectionsCount=0;
	m_strFolder="";
}

CSimple3DObject::CSimple3DObject(const string & p_strFolder,float p_fGraphQuality,float p_fStructureFlexibility)
{
	
	
	CGLFrame *glframe=new CGLFrame((int)(p_fGraphQuality*C3DObject::GetGlobalGraphQuality()));
	C3DCursor cursor(0.0,0.0,0.0,glframe);
	int n;

	/*
	ifstream infile;
	string strFullPath,strFileName;
	const int MAX_BUFF=81;
	char buff[MAX_BUFF];
	int nLinesCount=0,nSelectedLine=0,n=0;

	strFullPath=p_strFolder+"/files.txt";
	infile.open(strFullPath.c_str());
	if (!infile) throw string("Cannot open file")+strFullPath+ "for read";
	while (!infile.eof())
	{
		nLinesCount++;
		infile.getline(buff,MAX_BUFF);
	}

	srand((unsigned)time(NULL));
	nSelectedLine=rand()%nLinesCount;

	for (n=0;n<nSelectedLine;n++)
		infile.getline(buff,MAX_BUFF);
	strFileName+=p_strFolder+'/'+buff;*/
	
	string strFileName=GetFileInFolder(p_strFolder);
	if (strFileName=="") throw "    ";
	cursor.LoadCommandsFromFile(strFileName.c_str());
	m_pFrame=glframe;

	m_strFolder=p_strFolder.c_str();

	m_nConnectionsCount=cursor.GetConnectionPointsCount();
	m_as3do=new CSimple3DObject*[m_nConnectionsCount];
	m_acp=new CConnectionPoint*[m_nConnectionsCount];
	m_fGraphQuality=p_fGraphQuality;
	m_fStructureFlexibility=p_fStructureFlexibility;
	for (n=0; n<m_nConnectionsCount;n++)
	{
		m_as3do[n]=NULL;
		m_acp[n]=new CConnectionPoint(cursor.GetConnectionPoint(n));
	}
}

CSimple3DObject::~CSimple3DObject()
{
	int n;
	for (n=0; n<m_nConnectionsCount;n++)
	{
		if (m_as3do[n]) delete m_as3do[n];
		if(m_acp[n]) delete m_acp[n];
	}
	if (m_as3do) delete []m_as3do;
	if (m_acp) delete [] m_acp;
}
bool CSimple3DObject::operator <(CSimple3DObject& p_s3do)
{
	return (m_strFolder<p_s3do.m_strFolder);
}

void CSimple3DObject::Draw()
{
	
	glPushMatrix();
	CGLVector3 parent=m_pFrame->GetParentPoint();
	glTranslatef(-parent.x,-parent.y,-parent.z);
	m_pFrame->Draw();
	int n;
	for (n=0; n<m_nConnectionsCount;n++)
	{
		glPushMatrix();
		
		glTranslatef(m_acp[n]->m_fx,m_acp[n]->m_fy,m_acp[n]->m_fz);
		if (m_as3do[n]) m_as3do[n]->Draw();
		glPopMatrix();
	}
	glPopMatrix();
	
}

void CSimple3DObject::SetConnectionToSimple3DObject(int p_nIndex, const string & p_strFolder,float p_fGraphQuality,float p_fStructureFlexibility)
{
	if (p_nIndex>m_nConnectionsCount) 
		throw "Index is out of bounds in CSimple3DObject::SetConnectionToSimple3DObject";
	CSimple3DObject *ps3do=new CSimple3DObject(p_strFolder,p_fGraphQuality,p_fStructureFlexibility);
	if (!ps3do) throw 1;
	delete m_as3do[p_nIndex];
	m_as3do[p_nIndex]=ps3do;
	
}

CSimple3DObject * CSimple3DObject::GetConnectedSimple3DObject(int p_nIndex) 
{
	return m_as3do[p_nIndex];
}

const CConnectionPoint & CSimple3DObject::GetConnectionPoint(int p_nIndex) 
{
	return *m_acp[p_nIndex];
}

void CSimple3DObject::SaveToFile(FILE * p_of)
{
	if (!p_of) throw 1;
	int n;
	n=m_strFolder.length();
	if (1!=fwrite((const void*)&n,sizeof(n),1,p_of)) throw 1; 
	if (n>0)
	{
		if (1!=fwrite((const void*)m_strFolder.c_str(),n,1,p_of)) throw 1;
	}
	if (1!=fwrite((const void*)&m_fGraphQuality,sizeof(m_fGraphQuality),1,p_of)) throw 1;
	if (1!=fwrite((const void*)&m_fStructureFlexibility,sizeof(m_fStructureFlexibility),1,p_of)) throw 1;

	for (n=0; n<m_nConnectionsCount;n++)
	{
		if (m_as3do[n]) m_as3do[n]->SaveToFile(p_of); 
		else
		{
			CSimple3DObject s3do;
			s3do.SaveToFile(p_of);
		}
	
	}
}

CSimple3DObject* CSimple3DObject::LoadFromFile(FILE* p_of)
{
	if (!p_of) throw 1;
	int n;
	float fGraphQuality,fStructureFlexibility;
	char * strFolder="";
	if (1!=fread((void*)&n,sizeof(n),1,p_of)) throw 1; 
	if (n>0)
	{
		strFolder=new char[n+1];
		if (1!=fread((void*)strFolder,n,1,p_of)) throw 1;
	}
	else
	{
		strFolder=new char[1];
	}
	strFolder[n]='\0';
	
	
	if (1!=fread((void*)&fGraphQuality,sizeof(fGraphQuality),1,p_of)) throw 1;
	if (1!=fread((void*)&fStructureFlexibility,sizeof(fStructureFlexibility),1,p_of)) throw 1;
	
	CSimple3DObject *ps3do=new CSimple3DObject(strFolder,fGraphQuality,fStructureFlexibility);
	delete [] strFolder;
	for (n=0; n<ps3do->m_nConnectionsCount;n++)
	{
		ps3do->m_as3do[n]=CSimple3DObject::LoadFromFile(p_of); 
		if (ps3do->m_as3do[n]->m_strFolder=="") 
		{
			delete ps3do->m_as3do[n];
			ps3do->m_as3do[n]=NULL;
		}
	}
	return ps3do;
}