////////////////////////////////////////////////////////////////////////////////
//: kurs.cpp
//:  Ը 
//: http://www.DXGames.narod.ru
//e-mail: UrvanovF@hotmail.ru
////////////////////////////////////////////////////////////////////////////////


#include "gl.h"
#include "floor.h"
#include "spacesheep.h"
#include "sky.h"
#include "3dobject.h"
#include "landscape.h"
#include "myutils.h"
#include "time.h"
#include <float.h>
#include "glTools.h"
#include <fstream.h>
void InitUserInterface(void);

GLfloat g_fx,g_fy,g_fz,g_fAngle,g_fRotate;
GLfloat g_fSpaceSheepY=-7.0;
enum SITUATION{
	S_GAME,
	S_EXPLOSION,
};
SITUATION g_Situation=S_GAME;

GLfloat g_fExplosionCounter;

void OnKeyboard(char c, int x, int y);
void OnSpecialKey(int key,int x, int y);
void OnRender(void);
void NewGame(void);


unsigned textureCubeMapId;
unsigned textureId;
unsigned int textureBlastId;
extern unsigned decalMap;

GLubyte * textureData=NULL;
GLubyte *scaledData=NULL;
int g_ScaledWidth=128,g_ScaledHeight=128;

int g_CopyWidth=g_ScaledWidth,g_CopyHeight=g_ScaledHeight,g_CopyX,g_CopyY;
int main(int argc, char * argv[])
{
	try{
		CGL::InitOpenGL("    .",&argc,argv);

		ifstream infile("config.txt");
		int nGlobalGraphQuality=40;
		int nSpacesheepGraphQuality=100;
		if (infile)
		{
			infile>>nGlobalGraphQuality;
			infile>>nSpacesheepGraphQuality;
			infile.close();
		}

		

		InitSky();
		InitFloor();
		C3DObject::SetGlobalGraphQuality(nSpacesheepGraphQuality);
		InitSpacesheep();
		C3DObject::SetGlobalGraphQuality(nGlobalGraphQuality);
		InitLandscape();
		

		glGenTextures(1,&textureBlastId);
		glBindTexture(GL_TEXTURE_2D,textureBlastId);
		loadBmpTexture(GL_TEXTURE_2D,true,"blast2.bmp");

		glGenTextures(1,&textureCubeMapId);
		glBindTexture(GL_TEXTURE_CUBE_MAP_ARB,textureCubeMapId);

			const char * maps [6] = 
	{
		"cm_left.tga", 
		"cm_right.tga", 
		"cm_top.tga", 
		"cm_bottom.tga", 
		"cm_back.tga", 
		"cm_front.tga", 
	};
		glGenTextures(1,&textureId);
		glBindTexture(GL_TEXTURE_2D,textureId);

		
	scaledData=new GLubyte[3*g_ScaledWidth*g_ScaledHeight];
	if (!scaledData) throw "Not enought memory\n";


	textureData=new GLubyte[3*g_CopyWidth*g_CopyHeight];
	int rwidth=CGL::GetWidth(),rheight=CGL::GetHeight();
	GLenum err;
	if (rheight<rwidth) g_CopyWidth=rheight;
	else g_CopyWidth=rwidth;
	g_CopyWidth=int(log(g_CopyWidth)/log(2));
	g_CopyWidth=pow(2,g_CopyWidth);
	g_CopyHeight=g_CopyWidth;

	g_CopyWidth=g_ScaledWidth;
	g_CopyHeight=g_ScaledHeight;

	g_CopyX=rwidth/2-g_CopyWidth/2;
	g_CopyY=rheight/2-g_CopyHeight/2;
	g_CopyX=0;
	g_CopyY=0;


	glBindTexture(GL_TEXTURE_2D,textureId);
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
	gluBuild2DMipmaps ( GL_TEXTURE_2D, 3,
		g_CopyWidth, g_CopyHeight,
		GL_RGB, GL_UNSIGNED_BYTE, textureData);

	if ((err=glGetError())!=GL_NO_ERROR) printf("Error building 2DMipmaps: %i",err);

	

	NewGame();

		//CGL::SetKeyboardProc(OnKeyboard);
		CGL::SetSpecialKeyProc(OnSpecialKey);
		CGL::SetRenderProc(OnRender);
		
		InitUserInterface();
		CGL::MainLoop();
	}
	catch(char *s)
	{
		fprintf(stderr,"%s",s);
	}
	catch(...)
	{
		fprintf(stderr,"A error detected");
	}
	return 0;
}

void OnKeyboard(char c, int x, int y)
{
	
}

void OnSpecialKey(int key,int x, int y)
{

	switch (key)
	{
	case GLUT_KEY_LEFT:
		g_fRotate=-1.0;

		
		break;
	case GLUT_KEY_RIGHT:
		g_fRotate=1.0f;

		break;
	case GLUT_KEY_F2:
		NewGame();
		break;
	}
	if (g_fAngle<0) g_fAngle=g_fAngle+360.0;
	if (g_fAngle>360) g_fAngle=g_fAngle-360.0;
}

void DrawWorld()
{

	DrawSky();
	//  
	glPushMatrix();
	DrawLandscape();
	glPopMatrix();

	// 
	glPushMatrix();
	//glTranslatef(n,-2.0,-1.0);
	glRotatef(90,-1.0,0.0,0.0);
	glTranslatef(0.0,0.0,0.0);
	DrawFloor();
	glPopMatrix();	
}


void SaveDataToFile(GLubyte *data0,int width,int height)
{
	FILE *file=fopen("out.bin","w");
	fwrite((const void*) data0,width*height*3,1,file);
	fclose(file);
}

void ScaleImage128(GLubyte *data0,GLubyte *scaledData)
{
	int n,m;
	int nmmax=128*128*3-1;
	for (n=0; n<128;n++)
	{
		for (m=0;m<128;m++)
		{
			int x,y;
			x=n*3;
			y=m*128*3;
			scaledData[nmmax-x-y-2]=data0[x+y];
			scaledData[nmmax-x-y-1]=data0[x+y+1];
			scaledData[nmmax-x-y]=data0[x+y+2];			
		}
	}
}

void CopyImage128(GLubyte *data0,GLubyte *scaledData)
{
	memcpy((void*)scaledData,(const void*)data0,128*128*3);
}

GLubyte * SaveScreenToCubeMap(unsigned int textureId,unsigned int textureCubeMapId,GLenum target,int Scale=1)
{
	try{
	GLubyte *data0=textureData;
	CreateScreenTexture(textureId,textureData,g_CopyX,g_CopyY,g_CopyWidth,g_CopyHeight);
	glGetTexImage(GL_TEXTURE_2D,0,GL_RGB,GL_UNSIGNED_BYTE,data0);
	glBindTexture(GL_TEXTURE_CUBE_MAP_ARB,textureCubeMapId);
	if (Scale)
	{
		ScaleImage128(data0,scaledData);
		
	}
	else
	{
		CopyImage128(data0,scaledData);
			
	}
	gluBuild2DMipmaps ( target, 3,
		             g_ScaledWidth,  g_ScaledHeight,
						GL_RGB, GL_UNSIGNED_BYTE, scaledData);
		return scaledData;
	}
	catch(GLenum err)
	{
		err=glGetError();
		fprintf(stderr,"Error saving screen to cube map: %i\n",err);
	}
	catch(...)
	{
		fprintf(stderr,"Error saving screen to cube map\n");
	}
	return NULL;
}


void SetupModelViewMatrix(void)
{
	glLoadIdentity();
	glRotatef(g_fAngle,0.0,1.0,0.0);
	glTranslatef(g_fx,g_fy,g_fz);
	

}

void SetupMatrixToSpaceSheep(void)
{
	//glRotatef(g_fAngle,0.0,-1.0,0.0);
	//glTranslatef(-g_fx,-g_fy,-g_fz);
	//glRotatef(g_fAngle,0.0,1.0,0.0);
	glTranslatef(0.0,0.0,0.0);
	//glTranslatef(-g_fx,-g_fy,-g_fz);

}

void OnRender(void)
{




	GLfloat tx,ty,tz;
	ty=g_fy;
	tx=g_fx-(20.0*sin(g_fAngle/360*2*GLT_PI));
	tz=g_fz+(20.0*cos(g_fAngle/360*2*GLT_PI));;
	if (IsInLandscape(tx,ty,tz))
		g_Situation=S_EXPLOSION;


	float n=0,m=0;
	GLenum err;
	const FLOOR_SIZE=100;
	static float fSpacesheepAngle=0.0;

	
	SetupModelViewMatrix();
	CGL::SetPointLight(GL_LIGHT1,CGLVector3(1000.0,100.0,0.0),CGLColor(1.0,1.0,1.0));
	

	if (g_Situation==S_EXPLOSION)
	{
		const int dr=2;
		glPushMatrix();
		if (g_fExplosionCounter<10)
			glTranslatef(float(rand()%dr-dr/2),float(rand()%dr-dr/2),float(rand()%dr-dr/2));
		DrawWorld();
		glPopMatrix();
		glDisable(GL_LIGHTING);
		glEnable(GL_TEXTURE_2D);
		glBindTexture(GL_TEXTURE_2D,textureBlastId);

		if (g_fExplosionCounter<10.0)
		{
			g_fExplosionCounter+=1.0;
			glPushMatrix();
			glLoadIdentity();
			glTranslatef(0.0,g_fSpaceSheepY,-20.0);
			glEnable(GL_TEXTURE_GEN_S);
			glEnable(GL_TEXTURE_GEN_T);
			glEnable(GL_TEXTURE_GEN_R);
			//glEnable(GL_TEXTURE_GEN_Q);
			glTexGeni(GL_S,GL_TEXTURE_GEN_MODE,GL_OBJECT_LINEAR);
			glTexGeni(GL_T,GL_TEXTURE_GEN_MODE,GL_OBJECT_LINEAR);
			glTexGeni(GL_R,GL_TEXTURE_GEN_MODE,GL_OBJECT_LINEAR);
			glTexGeni(GL_Q,GL_OBJECT_PLANE,GL_SPHERE_MAP);
			glutSolidSphere(g_fExplosionCounter,C3DObject::GetGlobalGraphQuality(),C3DObject::GetGlobalGraphQuality());
			glDisable(GL_TEXTURE_GEN_T);	
			glDisable(GL_TEXTURE_GEN_S);
			glDisable(GL_TEXTURE_GEN_R);
			glDisable(GL_TEXTURE_GEN_Q);
	
			if (g_fExplosionCounter>5)
			{
				GLUquadricObj * pObj;
				pObj=gluNewQuadric();
				pObj = gluNewQuadric();
				gluQuadricDrawStyle(pObj, GLU_FILL);
				gluQuadricNormals(pObj, GLU_SMOOTH);
				gluQuadricOrientation(pObj, GLU_INSIDE);
				//gluQuadricTexture(pObj, GLU_TRUE);
	
				glRotatef(90,1.0,0.0,0.0);
				float radius=g_fExplosionCounter*2;
				gluDisk(pObj,radius-4, radius, 10, 1);
				gluDeleteQuadric(pObj);
			}
		}	
		glEnable(GL_LIGHTING);
		glDisable(GL_TEXTURE_2D);
	}
	else
	{
		GLfloat fStep=2.0;
		g_fx=g_fx-(fStep*sin(g_fAngle/360*2*GLT_PI));
		g_fz=g_fz+(fStep*cos(g_fAngle/360*2*GLT_PI));
		if (g_fRotate!=0.0)
		{
			g_fAngle+=g_fRotate*10.0;
			g_fRotate=0.0;
		}
		static GLubyte *data0,*data1,*data2,*data3,*data4,*data5;
		glBindTexture   ( GL_TEXTURE_CUBE_MAP_ARB, textureCubeMapId );
		err=glGetError();
		glTexParameterf ( GL_TEXTURE_CUBE_MAP_ARB, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE );
		glTexParameterf ( GL_TEXTURE_CUBE_MAP_ARB, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE );
		glTexParameteri ( GL_TEXTURE_CUBE_MAP_ARB, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR );
		glTexParameteri ( GL_TEXTURE_CUBE_MAP_ARB, GL_TEXTURE_MAG_FILTER, GL_LINEAR );
		
		bool mipmap=true;
		glViewport(0,0,g_CopyWidth,g_CopyHeight);
		glMatrixMode(GL_PROJECTION);
		glLoadIdentity();
		gluPerspective(90,1,1.0,FLT_MAX);
		glMatrixMode(GL_MODELVIEW);
		glPushMatrix();
		glLoadIdentity();
		glRotatef(g_fAngle,0.0,1.0,0.0);
		glRotatef(90,0.0,1.0,0.0);
		glTranslatef(g_fx,g_fy,g_fz);
		//glRotatef(g_fAngle,0.0,-1.0,0.0);
		glTranslatef(0.0,g_fSpaceSheepY,0.0);	
		//glRotatef(g_fAngle,0.0,1.0,0.0);	
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT |GL_STENCIL_BUFFER_BIT);
		CGL::SetPointLight(GL_LIGHT1,CGLVector3(1000.0,100.0,0.0),CGLColor(1.0,1.0,1.0));
		DrawWorld();
		data0=SaveScreenToCubeMap(textureId,textureCubeMapId,GL_TEXTURE_CUBE_MAP_POSITIVE_X_ARB);	
		glPopMatrix();
	
	
		glPushMatrix();
		glLoadIdentity();
		glRotatef(90,0.0,-1.0,0.0);
		glRotatef(g_fAngle,0.0,1.0,0.0);
		glTranslatef(g_fx,g_fy,g_fz);
		glTranslatef(0.0,g_fSpaceSheepY,0.0);
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT |GL_STENCIL_BUFFER_BIT);
		CGL::SetPointLight(GL_LIGHT1,CGLVector3(1000.0,100.0,0.0),CGLColor(1.0,1.0,1.0));
		DrawWorld();	
		data1=SaveScreenToCubeMap(textureId,textureCubeMapId,GL_TEXTURE_CUBE_MAP_NEGATIVE_X_ARB);	
		glPopMatrix();

	
		glPushMatrix();
		glLoadIdentity();
		glRotatef(90,-1.0,0.0,0.0);	
		glRotatef(g_fAngle,0.0,1.0,0.0);
		glTranslatef(g_fx,g_fy,g_fz);
		glTranslatef(0.0,g_fSpaceSheepY,0.0);	
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT |GL_STENCIL_BUFFER_BIT);
		CGL::SetPointLight(GL_LIGHT1,CGLVector3(1000.0,100.0,0.0),CGLColor(1.0,1.0,1.0));
		DrawWorld();	
		data2=SaveScreenToCubeMap(textureId,textureCubeMapId,GL_TEXTURE_CUBE_MAP_POSITIVE_Y_ARB,0);	
		glPopMatrix();

		glPushMatrix();
		glLoadIdentity();
		glRotatef(90,1.0,0.0,0.0);
		glRotatef(g_fAngle,0.0,1.0,0.0);
		glTranslatef(g_fx,g_fy,g_fz);
		glTranslatef(0.0,g_fSpaceSheepY,0.0);
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT |GL_STENCIL_BUFFER_BIT);
		CGL::SetPointLight(GL_LIGHT1,CGLVector3(1000.0,100.0,0.0),CGLColor(1.0,1.0,1.0));
		DrawWorld();	
		data3=SaveScreenToCubeMap(textureId,textureCubeMapId,GL_TEXTURE_CUBE_MAP_NEGATIVE_Y_ARB,0);	
		glPopMatrix();

		glPushMatrix();
		glLoadIdentity();
		glRotatef(180,0.0,1.0,0.0);
		glRotatef(g_fAngle,0.0,1.0,0.0);
		glTranslatef(g_fx,g_fy,g_fz);
		glTranslatef(0.0,g_fSpaceSheepY,0.0);
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT |GL_STENCIL_BUFFER_BIT);
		CGL::SetPointLight(GL_LIGHT1,CGLVector3(1000.0,100.0,0.0),CGLColor(1.0,1.0,1.0));
		DrawWorld();	
		data4=SaveScreenToCubeMap(textureId,textureCubeMapId,GL_TEXTURE_CUBE_MAP_POSITIVE_Z_ARB);	
		glPopMatrix();
	
		glPushMatrix();
		glLoadIdentity();
		glRotatef(g_fAngle,0.0,1.0,0.0);
		glTranslatef(g_fx,g_fy,g_fz);
		glTranslatef(0.0,g_fSpaceSheepY,0.0);
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT |GL_STENCIL_BUFFER_BIT);
		CGL::SetPointLight(GL_LIGHT1,CGLVector3(1000.0,100.0,0.0),CGLColor(1.0,1.0,1.0));
		DrawWorld();	
		data5=SaveScreenToCubeMap(textureId,textureCubeMapId,GL_TEXTURE_CUBE_MAP_NEGATIVE_Z_ARB);	
		glPopMatrix();

		CGL::OnResize(CGL::GetWidth(),CGL::GetHeight());

		//  

		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT |GL_STENCIL_BUFFER_BIT);
		CGL::SetPointLight(GL_LIGHT1,CGLVector3(1000.0,100.0,0.0),CGLColor(1.0,1.0,1.0));
		DrawWorld();
		glPushMatrix();
		glLoadIdentity();
		glTranslatef(0.0,g_fSpaceSheepY,-20.0);
		glRotatef(180,0.0,1.0,0.0);
		DrawSpacesheep(textureCubeMapId);
		glPopMatrix();
		//glPopMatrix();
	}



}



void OnHelp(void)
{
	CGL::RemoveAllControls();
	CGLControl*p;
	p=new CGLTextBox(-0.5,0.5,1.0,1.0,"     . \
		   Ը   2007 .\
		 : http://www.DXGames.narod.ru \
		  e-mail: urvanovf@hotmail.ru");
	p= new CGLButton(-0.2,-0.6,0.4,0.1,"OK",InitUserInterface);
}
void InitUserInterface(void)
{
	CGL::RemoveAllControls();
	CGLControl *p;
	p=new CGLButton(-0.9,0.9,0.5,0.1," (F2)",NewGame);
	if (!p) throw 1;
	p=new CGLButton(0.5,0.9,0.5,0.1,"",OnHelp);
}

void NewGame(void)
{
	g_fx=-100.0;
	g_fy=-15.0;
	g_fz=-0.0;
	g_fAngle=0.0;
	g_fRotate=0.0;
	g_Situation=S_GAME;
	g_fExplosionCounter=0.0;
}

