////////////////////////////////////////////////////////////////////////////////
//: landscape.cpp
//:  Ը 
//: http://www.DXGames.narod.ru
//e-mail: UrvanovF@hotmail.ru
////////////////////////////////////////////////////////////////////////////////

#include "landscape.h"
#include "gl.h"
#include "3dobject.h"
#include "cpputils.h"
#include "myutils.h"
#include "3dcursor.h"
#include "GLTools.h"
const int MAX_LANDSCAPES=20;
const int MAX_LANDSCAPES_FRAME=2;
CGLFrame * g_apglfLandscapes[MAX_LANDSCAPES_FRAME];
GLfloat g_maxX=0.0,g_maxZ=0.0;
class CLandscape{
public:
	CGLFrame *m_pFrame;
	GLfloat x,y,z;
	GLfloat Angle;
};

CLandscape g_Landscapes[MAX_LANDSCAPES];


void TransformPoint(const GLTVector3 vSrcVector, const GLTMatrix mMatrix, GLTVector3 vOut)
    {
    vOut[0] = mMatrix[0] * vSrcVector[0] + mMatrix[4] * vSrcVector[1] + mMatrix[8] *  vSrcVector[2] + mMatrix[12];
    vOut[1] = mMatrix[1] * vSrcVector[0] + mMatrix[5] * vSrcVector[1] + mMatrix[9] *  vSrcVector[2] + mMatrix[13];
    vOut[2] = mMatrix[2] * vSrcVector[0] + mMatrix[6] * vSrcVector[1] + mMatrix[10] * vSrcVector[2] + mMatrix[14];    
   }

void InitLandscape(void)
{
	int n;
	printf("Loading landscapes.\n");
	printf("Loading mountain4...");
	CGLFrame * pFrame=new CGLFrame(C3DObject::GetGlobalGraphQuality());
	if (!pFrame) throw 1;
	C3DCursor cursor(0.0,0.0,0.0,pFrame);
	cursor.LoadCommandsFromFile("mountain/_mountain4");
	g_apglfLandscapes[0]=pFrame;
	WriteOk();

	printf("Loading mountain5...");
	pFrame=new CGLFrame(C3DObject::GetGlobalGraphQuality());
	if (!pFrame) throw 1;
	C3DCursor cursor2(0.0,0.0,0.0,pFrame);
	cursor2.LoadCommandsFromFile("mountain/_mountain5");
	g_apglfLandscapes[1]=pFrame;
	WriteOk();


	CGLVertex * Vertices;
	Vertices=g_apglfLandscapes[0]->GetVertices();
	for (n=0; n<g_apglfLandscapes[0]->GetCountVertices();n++)
	{
		if (fabs(Vertices[n].m_Vertex.x)>g_maxX) g_maxX=fabs(Vertices[n].m_Vertex.x);
		if (fabs(Vertices[n].m_Vertex.z)>g_maxZ) g_maxZ=fabs(Vertices[n].m_Vertex.z);

	}
	g_maxX=g_maxX/2;
	g_maxZ=g_maxZ/2;
	const int SIZE=100;
	const int TWO_SIZE=SIZE*2;
	for (n=0; n<MAX_LANDSCAPES;n++)
	{
		g_Landscapes[n].x=rand()%TWO_SIZE-SIZE;//-15;//0.010-50+rand()%100;
		g_Landscapes[n].y=6.0;//rand()%TWO_SIZE-SIZE;//6.0;//-50+rand()%100;
		g_Landscapes[n].z=rand()%TWO_SIZE-SIZE;//n*12;//-n*15;//-50+rand()%100;
		g_Landscapes[n].Angle=rand()%360;
		g_Landscapes[n].m_pFrame=g_apglfLandscapes[rand()%MAX_LANDSCAPES_FRAME];
	}


}

int IsInLandscape(GLfloat x,GLfloat y,GLfloat z)
{
	int n;
	GLfloat tx,ty,tz;
	for (n=0; n<MAX_LANDSCAPES;n++)
	{
		tx=x+g_Landscapes[n].x;
		ty=y+g_Landscapes[n].y;
		tz=z+g_Landscapes[n].z;
		GLTMatrix mMatrix;
		gltRotationMatrix(g_Landscapes[n].Angle, tx, ty,tz, mMatrix);
		GLTVector3 vSrcVector={tx,ty,tz},vOut={tx,ty,tz};
		TransformPoint(vSrcVector, mMatrix, vOut);
		if ((fabs(vOut[0])<g_maxX)&& (fabs(vOut[2])<g_maxZ))
			return 1;
		
	}
	return 0;

}

void DrawLandscape(void)
{
	int n;
	for (n=0; n<MAX_LANDSCAPES;n++)
	{
		glPushMatrix();
		glTranslatef(g_Landscapes[n].x,g_Landscapes[n].y,g_Landscapes[n].z);
		glRotatef(g_Landscapes[n].Angle,0.0,1.0,0.0);
		
		g_Landscapes[n].m_pFrame->Draw();
		glPopMatrix();
	}

}