////////////////////////////////////////////////////////////////////////////////
//: myutils.cpp
//:  Ը 
//: http://www.DXGames.narod.ru
//e-mail: UrvanovF@hotmail.ru
////////////////////////////////////////////////////////////////////////////////

#include	<windows.h>
#include	<stdio.h>
#include	<string.h>
#include	<gl/gl.h>
#include	<gl/glut.h>
#include	<gl/glaux.h>
#include	"glext.h"
#include "cpputils.h"
#include "time.h"
#include	"Vector3D.h"
#include	"Vector2D.h"
#include "myutils.h"
#include "gl.h"

extern "C"
{
	#include	"tga.h"
}

char *strOK=" [  OK  ] ";
void WriteOk(void)
{
	printf("%s%s",strOK,cpputils::GetTimeString());
}


unsigned	createTexture2D ( bool mipmap, const char * fileName )
{
	unsigned	textureId;

	glGenTextures   ( 1, &textureId );
	glBindTexture   ( GL_TEXTURE_2D, textureId );
	glPixelStorei   ( GL_UNPACK_ALIGNMENT, 1 );							// set 1-byte alignment

	glTexParameteri ( GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT );	// set texture to repeat mode
	glTexParameteri ( GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT );

	loadTexture ( GL_TEXTURE_2D, mipmap, fileName );

	glTexParameteri   ( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR );	
	glTexParameteri   ( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR );

	return textureId;
}

/*
unsigned	createCubeMap ( bool mipmap, const char * maps [] )
{
	unsigned	textureId;

	glGenTextures   ( 1, &textureId );
	glBindTexture   ( GL_TEXTURE_CUBE_MAP_ARB, textureId );
	glPixelStorei   ( GL_UNPACK_ALIGNMENT, 1 );							// set 1-byte alignment

	glTexParameterf ( GL_TEXTURE_CUBE_MAP_ARB, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE );
	glTexParameterf ( GL_TEXTURE_CUBE_MAP_ARB, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE );

	loadTexture     ( GL_TEXTURE_CUBE_MAP_POSITIVE_X_ARB, mipmap, maps [0] );
	loadTexture     ( GL_TEXTURE_CUBE_MAP_NEGATIVE_X_ARB, mipmap, maps [1] );
	loadTexture     ( GL_TEXTURE_CUBE_MAP_POSITIVE_Y_ARB, mipmap, maps [2] );
	loadTexture     ( GL_TEXTURE_CUBE_MAP_NEGATIVE_Y_ARB, mipmap, maps [3] );
	loadTexture     ( GL_TEXTURE_CUBE_MAP_POSITIVE_Z_ARB, mipmap, maps [4] );
	loadTexture     ( GL_TEXTURE_CUBE_MAP_NEGATIVE_Z_ARB, mipmap, maps [5] );

	glEnable ( GL_TEXTURE_CUBE_MAP_ARB );

	if ( mipmap )
	{
		glTexParameteri ( GL_TEXTURE_CUBE_MAP_ARB, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR );
		glTexParameteri ( GL_TEXTURE_CUBE_MAP_ARB, GL_TEXTURE_MAG_FILTER, GL_LINEAR );
	} 
	else 
	{
		glTexParameteri ( GL_TEXTURE_CUBE_MAP_ARB, GL_TEXTURE_MIN_FILTER, GL_LINEAR );
		glTexParameteri ( GL_TEXTURE_CUBE_MAP_ARB, GL_TEXTURE_MAG_FILTER, GL_LINEAR );
	}

	return textureId;
}

  */


unsigned	createCubeMap ( bool mipmap, const char * maps [] )
{
	unsigned	textureId;

	glGenTextures   ( 1, &textureId );
	glBindTexture   ( GL_TEXTURE_CUBE_MAP_ARB, textureId );
	


	loadTexture     ( GL_TEXTURE_CUBE_MAP_POSITIVE_X_ARB, mipmap, maps [0] );
	loadTexture     ( GL_TEXTURE_CUBE_MAP_NEGATIVE_X_ARB, mipmap, maps [1] );
	loadTexture     ( GL_TEXTURE_CUBE_MAP_POSITIVE_Y_ARB, mipmap, maps [2] );
	loadTexture     ( GL_TEXTURE_CUBE_MAP_NEGATIVE_Y_ARB, mipmap, maps [3] );
	loadTexture     ( GL_TEXTURE_CUBE_MAP_POSITIVE_Z_ARB, mipmap, maps [4] );
	loadTexture     ( GL_TEXTURE_CUBE_MAP_NEGATIVE_Z_ARB, mipmap, maps [5] );



/*	if ( mipmap )
	{
	} 
	else 
	{
		glTexParameteri ( GL_TEXTURE_CUBE_MAP_ARB, GL_TEXTURE_MIN_FILTER, GL_LINEAR );
		glTexParameteri ( GL_TEXTURE_CUBE_MAP_ARB, GL_TEXTURE_MAG_FILTER, GL_LINEAR );
	}*/

	return textureId;
}


bool	loadTexture ( int target, bool mipmap, const char * fileName )
{
	const char * ext = strrchr ( fileName, '.' );

	if ( ext == NULL )
		return false;

	if ( !stricmp ( ext + 1, "bmp" ) )
		return loadBmpTexture ( target, mipmap, fileName );
	else
	if ( !stricmp ( ext + 1, "tga" ) )
		return loadTgaTexture ( target, mipmap, fileName );

	printf ( "oops\n" );

	return false;
}

bool	loadTgaTexture ( int target, bool mipmap, const char * fileName )
{
	FILE            * file;
	gliGenericImage * image;

	file = fopen ( fileName, "rb" );

	if ( file == NULL )
	{
		printf ( "Error loading %s.\n", fileName );

		return false;
	}

	image = gliReadTGA ( file, (char *)fileName );

	fclose ( file );

	if ( mipmap )
		gluBuild2DMipmaps ( target, image -> components,
			                image -> width, image -> height,
							image -> format, GL_UNSIGNED_BYTE, image -> pixels );
	else
	    glTexImage2D (      target, 0, image -> components,
				            image -> width, image -> height, 0,
							image -> format, GL_UNSIGNED_BYTE, image -> pixels );
	return true;
}

bool	loadBmpTexture ( int target, bool mipmap, const char * fileName )
{
								// load texture
	AUX_RGBImageRec * texture = auxDIBImageLoad ( fileName );

	if ( texture == NULL )
	{
		printf ( "Error loading %s.\n", fileName );

		return false;
	}

	if ( mipmap )
		gluBuild2DMipmaps ( target, GL_RGB, 
			                texture -> sizeX, texture -> sizeY, 
				            GL_RGB, GL_UNSIGNED_BYTE, 
					        texture -> data );
	else
	    glTexImage2D ( target, 0, GL_RGB,
					   texture -> sizeX, texture -> sizeY, 0,
					   GL_RGB, GL_UNSIGNED_BYTE, texture -> data );


	return true;
}

bool	isExtensionSupported ( const char * ext )
{
	const char * extensions = (const char *)glGetString ( GL_EXTENSIONS );
	const char * start      = extensions;
	const char * ptr;

	while ( ( ptr = strstr ( start, ext ) ) != NULL )
	{
											// we've found, ensure name is exactly ext
		const char * end = ptr + strlen ( ext );

		if ( isspace ( *end ) || *end == '\0' )
			return true;

		start = end;
	}

	return false;
}

void CreateScreenTexture(unsigned textureId,GLubyte * textureData,int x,int y,int width,int  height)
{

	GLenum err;
	glBindTexture(GL_TEXTURE_2D,textureId);

	glTexImage2D(GL_TEXTURE_2D,0, 3,
		width, height,0,
		GL_RGB, GL_UNSIGNED_BYTE, textureData);
	if ((err=glGetError())!=GL_NO_ERROR) printf("Error building 2DMipmaps: %i\n",err);

	glCopyTexSubImage2D(
		GL_TEXTURE_2D,           
		0,      
		0,
		 0,
		 x,                 
		y,                 
	width, height
		           
	);
	if ((err=glGetError())!=GL_NO_ERROR)
	{
		fprintf(stderr,"Error copying tex image: %i\n",err);
		throw 1;
	}

	
}