////////////////////////////////////////////////////////////////////////////////
//: sky.cpp
//:  Ը 
//: http://www.DXGames.narod.ru
//e-mail: UrvanovF@hotmail.ru
////////////////////////////////////////////////////////////////////////////////

#include "sky.h"

#include "gl.h"
#include <GL/gl.h>
#include <GLEXT.H>
#include <stdio.h>
#include <stdlib.h>
#include <float.h>
#include <math.h>
#include "myutils.h"

unsigned int g_texLeft,g_texRight,g_texTop,g_texBottom,g_texFront,g_texBack;
GLubyte * g_dataLeft=NULL,*g_dataRight=NULL,*g_dataTop=NULL,*g_dataBottom=NULL,*g_dataFront=NULL,*g_dataBack=NULL;


int LoadSkyTexture(unsigned int p_nTexture,GLubyte **p_data,const char * filepath);
void InitSky(void)
{
	glGenTextures(1,&g_texLeft);
	glGenTextures(1,&g_texRight);
	glGenTextures(1,&g_texTop);
	glGenTextures(1,&g_texBottom);
	glGenTextures(1,&g_texFront);
	glGenTextures(1,&g_texBack);



	if (!LoadSkyTexture(g_texFront,&g_dataFront,"sky/f.raw"))
		throw "Error loading front texture\n";
	if (!LoadSkyTexture(g_texBack,&g_dataBack,"sky/b.raw"))
		throw "Error loading back texture\n";
	if (!LoadSkyTexture(g_texLeft,&g_dataLeft,"sky/l.raw"))
		throw "Error loading left texture=n";
	if (!LoadSkyTexture(g_texRight,&g_dataRight,"sky/r.raw")) 
		throw "Error loading right texture";
	if (!LoadSkyTexture(g_texTop,&g_dataTop,"sky/o.raw"))
		throw "Error loading top texture";
	if (!LoadSkyTexture(g_texBottom,&g_dataBottom,"sky/earth.raw"))
		throw "Error loading bottom texture\n";
}

void DrawSky(void)
{
	static const float SIZE=sqrt(FLT_MAX/2);
	glPushAttrib(GL_ALL_ATTRIB_BITS);
	glEnable(GL_TEXTURE_2D);
	glDisable(GL_LIGHTING);
	glBindTexture(GL_TEXTURE_2D,g_texBack);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);

	glColor3f(1.0,0.5,0.0); //Ƹ
	//glColor3f(1.0,1.0,1.0);
	glBegin(GL_TRIANGLE_FAN);
		//glColor3f(1.0,1.0,1.0);
		glNormal3f(0.0,0.0,1.0);
		
		glTexCoord2i(0,0);
		glVertex3f(-SIZE,SIZE,-SIZE);
		
		
		glTexCoord2i(0,1);
		glVertex3f(-SIZE,-SIZE,-SIZE);
		
		
		glTexCoord2i(1,1);
		glVertex3f(SIZE,-SIZE,-SIZE);
		
		glTexCoord2f(1.0,0.0);
		glVertex3f(SIZE,SIZE,-SIZE);
	glEnd();

	glBindTexture(GL_TEXTURE_2D,g_texLeft);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);

	glBegin(GL_TRIANGLE_FAN);
		//glColor3f(1.0,1.0,1.0);
		glNormal3f(1.0,0.0,0.0);
		
		glTexCoord2i(1,0.0);
		glVertex3f(-SIZE,SIZE,-SIZE);
		
		
		glTexCoord2i(0.0,0.0);
		glVertex3f(-SIZE,SIZE,SIZE);

		
		glTexCoord2i(0.0,1);
		glVertex3f(-SIZE,-SIZE,SIZE);

		glTexCoord2i(1,1);
		glVertex3f(-SIZE,-SIZE,-SIZE);
		

	glEnd();

	glBindTexture(GL_TEXTURE_2D,g_texRight);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);

	glBegin(GL_TRIANGLE_FAN);
		//glColor3f(1.0,1.0,1.0);
		glNormal3f(-1.0,0.0,0.0);
		
		glTexCoord2i(0,0);
		glVertex3f(SIZE,SIZE,-SIZE);
		
		
		glTexCoord2i(0,1);
		glVertex3f(SIZE,-SIZE,-SIZE);

		
		glTexCoord2i(1,1);
		glVertex3f(SIZE,-SIZE,SIZE);

		glTexCoord2f(1.0,0.0);
		glVertex3f(SIZE,SIZE,SIZE);
	glEnd();

	glBindTexture(GL_TEXTURE_2D,g_texTop);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);

	glBegin(GL_TRIANGLE_FAN);
		//glColor3f(1.0,1.0,1.0);
		glNormal3f(0.0,-1.0,0.0);
		
		glTexCoord2i(0,0);
		glVertex3f(SIZE,SIZE,-SIZE);
		
		glTexCoord2i(0,1);
		glVertex3f(SIZE,SIZE,SIZE);

		
		glTexCoord2i(1,1);
		glVertex3f(-SIZE,SIZE,SIZE);
		
		glTexCoord2i(1,0);
		glVertex3f(-SIZE,SIZE,-SIZE);
	glEnd();


	glBindTexture(GL_TEXTURE_2D,g_texFront);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);

	glBegin(GL_TRIANGLE_FAN);
	
		//glColor3f(1.0,1.0,1.0);
		glNormal3f(0.0,0.0,1.0);
		
		glTexCoord2i(1,0);
		glVertex3f(-SIZE,SIZE,SIZE);
				
		glTexCoord2i(0,0);
		glVertex3f(SIZE,SIZE,SIZE);
		
		glTexCoord2i(0,1);
		glVertex3f(SIZE,-SIZE,SIZE);

		glTexCoord2i(1,1);
		glVertex3f(-SIZE,-SIZE,SIZE);
	glEnd();


	glBindTexture(GL_TEXTURE_2D,g_texBottom);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);

	glBegin(GL_TRIANGLE_FAN);
		//glColor3f(1.0,1.0,1.0);
		glNormal3f(0.0,-1.0,0.0);
		
		glTexCoord2i(0,0);
		glVertex3f(SIZE,-SIZE,-SIZE);
		
		glTexCoord2i(1,0);
		glVertex3f(-SIZE,-SIZE,-SIZE);

		glTexCoord2i(1,1);
		glVertex3f(-SIZE,-SIZE,SIZE);

		glTexCoord2i(0,1);
		glVertex3f(SIZE,-SIZE,SIZE);

		

		

	glEnd();


	//glFrontFace(GL_CW);    // Counter clock-wise polygons face out
    //glEnable(GL_CULL_FACE);   // Do not calculate inside of jet
	//glutSolidCube(10);

	glPopAttrib();
}

int LoadSkyTexture(unsigned int p_nTexture,GLubyte **p_data,const char * filepath)
{
	GLenum err;
	if ((*p_data)) delete [] (*p_data);
	const int SIZE=3*512*512;
	(*p_data)=new GLubyte[SIZE];
	if (!(*p_data)) return 0;


	FILE * ifile=fopen(filepath,"rb");
	if (!ifile) return 0;

	if (SIZE!=fread((void*)(*p_data),1,SIZE,ifile))
	{
		fclose(ifile);
		return 0;
	}
	glBindTexture(GL_TEXTURE_2D,p_nTexture);
	gluBuild2DMipmaps(GL_TEXTURE_2D,GL_RGB8,
		512,512,
		GL_RGB,
		GL_UNSIGNED_BYTE,
		(*p_data));
	err=glGetError();
	if (err!=GL_NO_ERROR) throw err;
	fclose(ifile);
	return 1;

}